/*
 * Copyright (C) 1997-2000 SpellCaster Telecommunications Inc.
 * $Id: babd.h,v 1.8 2004/10/19 17:10:22 bcrl Exp $
 * Released under the GNU Public License. See LICENSE file for details.
 */
 
#ifndef BABD_H
#define BABD_H

#include <stdio.h>

extern struct timeval timer_getdelay(void);
extern void timer_run(void);
extern void setup_select(int fd, void *data, void (*read_cb)(int fd, void *data), void (*write_cb)(int fd, void *data));
extern int aps_init(void);
extern void aps_cleanup(void);
extern void bab_poll(void);
extern void bab_init(void);
extern char *iface_name(void *ifc, char *name);
extern char *strcause(unsigned char);
extern int l2tp_setup(FILE *cfg);
extern unsigned long strtoip(const char *);

class ctrlfd_t;
extern int do_l2tpctl(ctrlfd_t *cfd, char *str);
extern void do_bradius(ctrlfd_t *cfd, const char *str);
extern void do_bpppoe(ctrlfd_t *cfd, const char *str);
extern int num_ifaces;

extern long debug;
extern int am_radius_client, am_radius_acct_client;
class AcctMessage_t;
extern void radius_acct(AcctMessage_t *);
extern char *iptostr(unsigned int);

class Call;
extern int do_bdial(ctrlfd_t *cfd, const char *site, const char *phone,
		    Call *call, int lcp_timeout = 0, int lcp_interval = 0);
extern int dyn_ip_enabled;
extern int want_mlcp;
extern void get_random(unsigned char *buf, int len);
void dfs_dump_interfaces(ctrlfd_t *cfd);

#endif
