/*
 * Copyright (C) 1997-2000 SpellCaster Telecommunications Inc.
 * $Id: call.h,v 1.3 2004/08/15 23:22:03 bcrl Exp $
 * Released under the GNU Public License. See LICENSE file for details.
 */


#ifndef CALL_H
#define CALL_H

#include "d_aps_if.h"

#include "ctrlfd.h"

extern unsigned int callIdent;

class CInterface;

class Call : public ctrlfd_die_listener {
public:
	CInterface	*m_iface;
	int		m_wait_for_hangup;
	unsigned int	ident;	/* semi-unique 'handle' for user apps to refer to the call */

	ctrlfd_t	*cfd;
	channel_t	*ch;

	virtual void ctrlfd_die_notification(ctrlfd_t *cfd) {
		cfd = NULL;
	}

	Call(int wait_for_hangup = 0, CInterface *iface = NULL) {
		m_iface = iface;
		m_wait_for_hangup = wait_for_hangup;
		ident = ++callIdent;
		cfd = NULL;
		ch = NULL;
	}

	virtual ~Call() {
		return;
	}
};

class DialResponse_t {
public:
	Call *call;
	int status;
	char msg[64];

	DialResponse_t()
	{
		status = 0;
		msg[0] = 0;
		call = 0;
	}

	DialResponse_t(Call *c)
	{
		status = 0;
		msg[0] = 0;
		call = c;
	}
};

#endif /* ndef CALL_H */

