/*
 * packet.h - Self explanitory
 * Copyright (C) 1997-2000 SpellCaster Telecommunications Inc.
 * $Id: packet.h,v 1.2 2004/07/19 02:58:27 bcrl Exp $
 * Released under the GNU Public License. See LICENSE file for details.
 */

#ifndef PACKET_H
#define PACKET_H

#include "kernel.h"
#include "usca.h"
#include "queue.h"

#define PPP_HEADER_LENGTH	2

class CLink;
class ctrlfd_t;
class dfs_object_t;

class CPppPacket : public CuscArray, public CQueueItem
{
public:
  CLink *link;
  CPppPacket() { CuscArray(); CQueueItem(); link = NULL; };
  CPppPacket(CLink *l) { CuscArray(); CQueueItem(); link = l; };
  CPppPacket(u8 *d, unsigned int l) : CuscArray(d, l) { link = NULL; };
  CPppPacket(CPppPacket *p) : CuscArray(p->m_start, p->GetLength()) { link = p->link; };

	CPppPacket(dfs_object_t *obj) :CuscArray(obj) {
		::CPppPacket();
	}

	void dump_full_state(ctrlfd_t *cfd);
};

#endif // PACKET_H



